import re

def check_saga_mark(model_list, level_data):
    error_model = dict()
    for model_id, level_arr in level_data.items():
        has_saga_mark = False
        for row in level_arr:
            floor_full_name = row.get('name')
            if floor_full_name.endswith('-saga'):
                # 如果重复包含-saga标记
                if has_saga_mark:
                    error_model[model_id] = '包含重复-saga标记'
                    break
                else:
                    has_saga_mark = True
                    floor_name = row.get('name')[0:len(floor_full_name) - 5]
                    # is_match = re.match(r'^([f|b][0-9]+|rf)(m[0-9]*)?$', floor_name)
                    is_match = re.match(r'^([F|B][1-9][0-9]{0,4}|RF)(M([1-9][0-9]{0,4})?)?$', floor_name)
                    # 如果格式有问题
                    if not is_match:
                        error_model[model_id] = '楼层名称不符合规则'
                        break
        # 如果所有楼层都没有包含-saga标记
        if not has_saga_mark:
            error_model[model_id] = '没有-saga标记'
    for row in model_list:
        if row.get('fid') in error_model:
            row['has_error'] = True
            row['error'] = error_model.get(row.get('fid'))
        else:
            row['has_error'] = False
            row['error'] = None

    if len(error_model) > 0:
        return False
    return True
